##############################################################################
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Thu Mar 1 20:54:52 2012
#  Last Modified : <200419.1052>
#
#  Description	
#
#  Notes
#
#  History
#	
##############################################################################
#
#  Copyright (c) 2012 Dr. Detlef Groth.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from Dr. Detlef Groth.
#
##############################################################################
#  swig -tcl -namespace cairo.i
# gcc -shared -fPIC -DUSE_TCL_STUBS \
# -I/usr/include/cairo -I/home/groth/project/opt/tcl/include cairo_wrap.c -o libcairo.so \
# -lcairo -L/home/groth/project/opt/tcl/lib -ltclstub8.4
# upx libcairo.so
# windows:
# gcc -shared -DUSE_TCL_STUBS  \
# -I/opt/tcl/include -I/src/libcairo/include/cairo/ cairo_wrap.c \
# -L/opt/tcl/lib -ltclstub84 -L/src/libcairo/lib/ -lcairo -olibcairo01.dll
load ./libcairo[info sharedlibextension]
#package require Tk
#set sf [::cairo::cairo_xlib_surface_create .test true true 100 100 test 1]
#pack $sf
set surface [::cairo::cairo_image_surface_create 0 100 100]
set cr [::cairo::cairo_create $surface]
::cairo::cairo_rectangle $cr 10 10 40 40
::cairo::cairo_set_source_rgb $cr 1 1 1
::cairo::cairo_fill $cr
::cairo::cairo_rectangle $cr 20 20 20 20
::cairo::cairo_set_source_rgb $cr 1 0 0
::cairo::cairo_fill $cr
::cairo::cairo_show_page $cr
::cairo::cairo_surface_write_to_png $surface cairo-test2.png
::cairo::cairo_rectangle $cr 60 60 20 20
::cairo::cairo_set_source_rgb $cr 0 1 0
::cairo::cairo_fill $cr
::cairo::cairo_show_page $cr
::cairo::cairo_surface_write_to_png $surface cairo-test3.png

set surface [::cairo::cairo_pdf_surface_create test.pdf 300 300]
set cr [::cairo::cairo_create $surface]
::cairo::cairo_rectangle $cr 10 10 40 40
::cairo::cairo_set_source_rgb $cr 1 1 1
::cairo::cairo_fill $cr
::cairo::cairo_rectangle $cr 20 20 20 20
::cairo::cairo_set_source_rgb $cr 1 0 0
::cairo::cairo_fill $cr
::cairo::cairo_show_page $cr
::cairo::cairo_surface_flush $surface
::cairo::cairo_surface_destroy $surface
::cairo::cairo_destroy $cr

set surface [::cairo::cairo_svg_surface_create test.svg 300 300]
set cr [::cairo::cairo_create $surface]
::cairo::cairo_rectangle $cr 10 10 40 40
::cairo::cairo_set_source_rgb $cr 1 1 1
::cairo::cairo_fill $cr
::cairo::cairo_rectangle $cr 20 20 20 20
::cairo::cairo_set_source_rgb $cr 1 0 0
::cairo::cairo_fill $cr
::cairo::cairo_show_page $cr
::cairo::cairo_surface_flush $surface
::cairo::cairo_surface_destroy $surface
::cairo::cairo_destroy $cr

set surface [::cairo::cairo_ps_surface_create test.ps 300 300]
set cr [::cairo::cairo_create $surface]
::cairo::cairo_rectangle $cr 10 10 40 40
::cairo::cairo_set_source_rgb $cr 1 1 1
::cairo::cairo_fill $cr
::cairo::cairo_rectangle $cr 20 20 20 20
::cairo::cairo_set_source_rgb $cr 1 0 0
::cairo::cairo_fill $cr
::cairo::cairo_show_page $cr
::cairo::cairo_surface_flush $surface
::cairo::cairo_surface_destroy $surface
::cairo::cairo_destroy $cr

if {[file isdirectory snit]} {
    lappend auto_path .
}
package require Tk
package require snit
snit::widget cimage {
    option -width 100
    option -height 100
    variable surface
    variable history [list]
    variable cr
    variable pngfile
    constructor {args} {
        $self configurelist $args
        pack [ttk::label $win.img -text "Hello"] ;#  -in $win -width $options(-width) -height $options(-height)
        set surface [::cairo::cairo_image_surface_create 0 $options(-width) $options(-height)]
        set cr [::cairo::cairo_create $surface]
        set pngfile [file tempfile].png
        ::cairo::cairo_rectangle $cr 1 1 98 98
        ::cairo::cairo_set_source_rgb $cr 1 1 1
        ::cairo::cairo_fill $cr
        $self cairo update

    }
    method cairo {cmd args} {
        if {[lsearch [list update fill show_text] $cmd] >= 0} {
            if {[lsearch [list fill show_text] $cmd] >= 0} {
                ::cairo::cairo_$cmd $cr {*}$args
                lappend history [list $cmd $args]
            }
            ::cairo::cairo_show_page $cr
            ::cairo::cairo_surface_write_to_png $surface $pngfile
            catch rename imgPng ""
            image create photo imgPng -file $pngfile
            $win.img configure -image imgPng
        } else {
            
            ::cairo::cairo_$cmd $cr {*}$args
            lappend history [list $cmd $args]
        }
    }
    method save {filename} {
        set ext [string range [file extension $filename] 1 end]
        set isurface [::cairo::cairo_${ext}_surface_create $filename $options(-width) $options(-height)]
        set icr [::cairo::cairo_create $isurface]
        foreach h $history {
            foreach {cmd args} $h break
            ::cairo::cairo_$cmd $icr {*}$args
        }
        ::cairo::cairo_show_page $icr
        ::cairo::cairo_surface_flush $isurface
        ::cairo::cairo_surface_destroy $isurface
        ::cairo::cairo_destroy $icr
    }
}

pack [cimage .img]

.img cairo rectangle 20 20 20 20
.img cairo set_source_rgb 1 0 0
.img cairo fill
.img cairo rectangle 50 20 20 20
.img cairo fill
.img cairo move_to 20 60
.img cairo set_source_rgb 0 0 0
.img cairo show_text "Hello World!"
.img save test3.svg
.img save test3.pdf
